//+------------------------------------------------------------------+
//|                                                      TestLog.mq5 |
//|                                     Copyright Paul Hampton-Smith |
//|                            http://paulsfxrandomwalk.blogspot.com |
//+------------------------------------------------------------------+
#property copyright "Paul Hampton-Smith"
#property link      "http://paulsfxrandomwalk.blogspot.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---

//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit()
  {
//---

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---

  }
//+------------------------------------------------------------------+

//#include <EnumToStr.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum EnumLogLevel
  {
   LOG_NONE,
   LOG_NORMAL,
   LOG_DEBUG,
   LOG_VERBOSE
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CLog
  {
public:

                     CLog()
     {
      m_hLogFile=0;
      m_LogLevel=LOG_NORMAL;
      m_dtLastFlushTime=0;
      m_uFlushRateSeconds=60;
      m_uLogFileMaxAgeDays=28;
      m_uLogStartDaysSince1970=0;
     }

                    ~CLog()
     {
      FileClose(m_hLogFile);
      m_hLogFile=0;
     }

   void Log(const EnumLogLevel Level,string strMsg)
     {
      if(Level<m_LogLevel)return;
      if(MQL5_OPTIMIZATION) return;
      datetime dtNow=TimeLocal();
      if(dtNow/(60*60*24)>m_uLogStartDaysSince1970 || m_hLogFile<=0)
        {
         // startup or new day
         if(m_hLogFile>0) FileClose(m_hLogFile);
         string strFilename=Filename(__FILE__,dtNow);
         m_hLogFile=FileOpen(strFilename,FILE_CSV|FILE_READ|FILE_WRITE);
         if(m_hLogFile<=0)
           {
            //            Print("Log() failed to open ",__FILE__,ErrorDescription(GetLastError()));
            return;
           }
         FileSeek(m_hLogFile,0,SEEK_END);
         m_uLogStartDaysSince1970=(uint)TimeLocal()/(60*60*24);
         if(!MQL5_TESTING) Print("Writing to log ",strFilename);

         // cleanup log from 4 weeks ago
         string strOldFilename=Filename(__FILE__,(datetime)dtNow-28*24*3600);
         if(FileIsExist(strOldFilename))
           {
            ResetLastError();
            FileDelete(strOldFilename);
            //            Log(LOG_NORMAL,"Log(): "+ErrorDescription(GetLastError())+" deleting "+(string)m_uLogFileMaxAgeDays+" day old logfile "+strOldFilename);
           }
        }
      if(MQL5_TESTING || m_hLogFile<=0)
        {
         Print(strMsg);
        }
      else
        {
         string outputmsg="";
         StringConcatenate(outputmsg,TimeToString(TimeLocal(),TIME_DATE|TIME_SECONDS)," ",strMsg);
         FileWrite(m_hLogFile,outputmsg);
        }
      if(TimeLocal()>(datetime)m_dtLastFlushTime+m_uFlushRateSeconds)
        {
         FileFlush(m_hLogFile);
         m_dtLastFlushTime=TimeLocal();
        }
     }

   // set
   EnumLogLevel LogLevel(const EnumLogLevel Level) {return(m_LogLevel=Level);} //
   uint MaxLogAge(const uint uDays){ return(m_uLogFileMaxAgeDays=uDays);}
   uint FlushRateSeconds(const uint uSeconds){ return(m_uFlushRateSeconds=uSeconds);}

   // get   
   EnumLogLevel LogLevel() {return(m_LogLevel);}
   uint MaxLogAge(){ return(m_uLogFileMaxAgeDays);}
   uint FlushRateSeconds(){ return(m_uFlushRateSeconds);}

   //+------------------------------------------------------------------+
   //|                                                                  |
   //+------------------------------------------------------------------+
protected:

   int               m_hLogFile;
   EnumLogLevel      m_LogLevel;
   datetime          m_dtLastFlushTime;
   uint              m_uFlushRateSeconds;
   uint              m_uLogFileMaxAgeDays;
   uint              m_uLogStartDaysSince1970;

   string Filename(string strName,datetime dt)
     {
      MqlDateTime mdt;
      TimeToStruct(dt,mdt);
      string strMonth=(string)mdt.mon;
      string strDay=(string)mdt.day;
      if(mdt.mon<10) strMonth="0"+strMonth;
      if(mdt.day<10) strDay="0"+strDay;
      string str=""; StringConcatenate(str,strName,"_",StringSubstr(Symbol(),0,6),"_",mdt.year,strMonth,strDay,"_log.txt");
      return(str);
     }

  };

//+------------------------------------------------------------------+
